; Screen
Graphics 800,600,32,2
SetBuffer BackBuffer()


; Each player has a Y position, a Speed, and a Score
Dim PlayerY#(2)
Dim PlayerSpeed#(2)
Dim PlayerScore(2)


; Each Ball has X and Y positions and Speeds
Type BallType
	Field x#,y#,xSpeed#,ySpeed#
End Type
Global ThisBall.BallType
Global NewBall.BallType


; Image Loading
Global img_Paddle_Left=LoadImage("../000-files/PaddleLeft.png")
Global img_Paddle_Right=LoadImage("../000-files/PaddleRight.png")
Global img_Ball=LoadImage("../000-files/Ball.png")

; Sound Loading
Global snd_Ball_Wall=LoadSound("../000-files/BallWall.wav")
Global snd_Ball_Paddle=LoadSound("../000-files/BallPaddle.wav")
Global snd_Score=LoadSound("../000-files/Score.wav")


; AI Variables
Global AI_Y
Global AI_X



; Add Paddles
PlayerY(0)=300
PlayerY(1)=300
PlayerSpeed(0)=0
PlayerSpeed(1)=0
PlayerScore(0)=0
PlayerScore(1)=0


; When Ball Timer hits 0, Add a new ball.
Global BallTimer=30

; Main loop
Repeat
Cls

DrawImage img_Paddle_Left,40,PlayerY(0)-32
DrawImage img_Paddle_Right,744,PlayerY(1)-32

; Keyboard cursors up and down to move player.
If KeyDown(200) Then PlayerSpeed(0)=PlayerSpeed(0)-.15
If KeyDown(208) Then PlayerSpeed(0)=PlayerSpeed(0)+.15
; For a complete list of Keyboard Scancodes, see http://socoder.net/scan.gif


; Computer AI
If PlayerY(1)>AI_Y Then PlayerSpeed(1)=PlayerSpeed(1)-.15
If PlayerY(1)<AI_Y Then PlayerSpeed(1)=PlayerSpeed(1)+.15



; Paddle Limits. Both identical, use a loop.
For n=0 To 1
	; If too fast, limit speed
	If PlayerSpeed(n)<-8 Then PlayerSpeed(n)=-4
	If PlayerSpeed(n)>8 Then PlayerSpeed(n)=4
	
	; If moving, try to slow down
	If PlayerSpeed(n)<0 Then PlayerSpeed(n)=PlayerSpeed(n)+.07
	If PlayerSpeed(n)>0 Then PlayerSpeed(n)=PlayerSpeed(n)-.07
	If PlayerSpeed(n)>-.05 And PlayerSpeed(n)<.05 Then PlayerSpeed(n)=0
	
	; Add to Y
	PlayerY(n)=PlayerY(n)+PlayerSpeed(n)
	
	If PlayerY(n)<72 Then PlayerY(n)=72
	If PlayerY(n)>548 Then PlayerY(n)=548
Next


; When Ball Timer hits 0, Add a new ball.
BallTimer=BallTimer-1
If BallTimer<=0
	NewBall.BallType=New BallType
	
	NewBall\x=400
	NewBall\y=300
	NewBall\ySpeed=Rnd(.5,2.5) : If Rand(0,1)=1 Then NewBall\ySpeed=-NewBall\ySpeed
	NewBall\xSpeed=Rnd(.5,2.5) : If Rand(0,1)=1 Then NewBall\xSpeed=-NewBall\xSpeed
	
	BallTimer=180
EndIf

; Reset AI
AI_X=-100

; Moving/Drawing Balls
For ThisBall.BallType=Each BallType
	; Move
	ThisBall\x=ThisBall\x+ThisBall\xSpeed
	ThisBall\y=ThisBall\y+ThisBall\ySpeed

	; If ball is coming towards us, watch it.
	If ThisBall\xSpeed>0 And ThisBall\x>AI_X
		AI_X=ThisBall\x
		AI_Y=ThisBall\y
	EndIf
	

	; Draw
	DrawImage img_Ball,ThisBall\x-8,ThisBall\y-8

	; Bounce off Top and Bottom
	If ThisBall\y<48 Then ThisBall\y=48 : ThisBall\ySpeed=Abs(ThisBall\ySpeed) : PlaySound(snd_Ball_Wall)
	If ThisBall\y>572 Then ThisBall\y=572 : ThisBall\ySpeed=-Abs(ThisBall\ySpeed) : PlaySound(snd_Ball_Wall)


	; Ball hits left bat
	If ImagesCollide(  img_Ball,ThisBall\x-8,ThisBall\y-8, 0,  img_Paddle_Left,40,PlayerY(0)-32, 0)
		ThisBall\x=72
		ThisBall\xSpeed=Abs(ThisBall\xSpeed)
		PlaySound(snd_Ball_Paddle)
	EndIf
	
	; Ball hits right bat
	If ImagesCollide(  img_Ball,ThisBall\x-8,ThisBall\y-8, 0,  img_Paddle_Right,744,PlayerY(1)-32, 0)
		ThisBall\x=728
		ThisBall\xSpeed=-Abs(ThisBall\xSpeed) : PlaySound(snd_Ball_Paddle)
	EndIf


	; If too far left or right, kill the ball and give opposite player a point.
	kill=0
	
	If ThisBall\x<-8 Then Kill=1 : PlayerScore(1)=PlayerScore(1)+1
	If ThisBall\x>808 Then Kill=1 : PlayerScore(0)=PlayerScore(0)+1	
	
	If Kill=1 Then Delete ThisBall
Next

; Draw game area
Color 255,255,255
Rect 0,40,800,8
Rect 0,580,800,8
Rect 396,40,8,540



Flip
Until KeyDown(1)